"use strict";
/**
 * Copyright 2019, Danang Galuh Tegar Prasetyo.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var OperationResult_1 = __importDefault(require("./OperationResult"));
var SelectOperationResult = /** @class */ (function (_super) {
    __extends(SelectOperationResult, _super);
    function SelectOperationResult(xResult, rows, metadata) {
        var _this = _super.call(this, xResult) || this;
        _this.rows = rows;
        _this.metadata = metadata;
        _this.objects = [];
        for (var _i = 0, _a = _this.rows; _i < _a.length; _i++) {
            var row = _a[_i];
            var object = {};
            var index = 0;
            for (var _b = 0, _c = _this.metadata; _b < _c.length; _b++) {
                var column = _c[_b];
                object[column.name] = row[index];
                index++;
            }
            _this.objects.push(object);
        }
        return _this;
    }
    SelectOperationResult.prototype.getRows = function () {
        return this.rows;
    };
    SelectOperationResult.prototype.getMetadata = function () {
        return this.metadata;
    };
    SelectOperationResult.prototype.getObjects = function () {
        return this.objects;
    };
    return SelectOperationResult;
}(OperationResult_1["default"]));
exports.SelectOperationResult = SelectOperationResult;
exports["default"] = SelectOperationResult;
//# sourceMappingURL=SelectOperationResult.js.map