/**
 * Copyright 2019, Danang Galuh Tegar Prasetyo.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import Client from './Client';
import Schema from './Schema';
import QueryExecutable from './QueryExecutable';
import { ISession } from './interfaces';
export declare class Session implements ISession {
    private readonly client;
    private readonly xSession;
    constructor(client: Client | null, xSession: any);
    getClient(): Client | null;
    getXSession(): any;
    commit(): Promise<boolean>;
    createSchema(name: string): Promise<Schema>;
    dropSchema(name: string): Promise<boolean>;
    getDefaultSchema(): Schema;
    getSchema(name: string): Schema;
    getSchemas(): Schema[];
    releaseSavepoint(name?: string): Promise<boolean>;
    rollback(): Promise<boolean>;
    rollbackTo(name?: string): Promise<boolean>;
    setSavepoint(name?: string): Promise<string>;
    sql(query: string): QueryExecutable;
    startTransaction(): Promise<boolean>;
}
export default Session;
