/**
 * Copyright 2019, Danang Galuh Tegar Prasetyo.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import ClientClass from './Client';
import SessionClass from './Session';
import * as Types from './types';
import * as Interfaces from './interfaces';
export declare type Client = Interfaces.IClient;
export declare type Collection = Interfaces.ICollection;
export declare type CollectionAdd = Interfaces.ICollectionAdd;
export declare type CollectionFind = Interfaces.ICollectionFind;
export declare type CollectionModify = Interfaces.ICollectionModify;
export declare type CollectionRemove = Interfaces.ICollectionRemove;
export declare type FindOperationResult = Interfaces.IFindOperationResult;
export declare type OperationResult = Interfaces.IOperationResult;
export declare type QueryExecutable = Interfaces.IQueryExecutable;
export declare type Schema = Interfaces.ISchema;
export declare type SelectOperationResult = Interfaces.ISelectOperationResult;
export declare type Session = Interfaces.ISession;
export declare type Table = Interfaces.ITable;
export declare type TableDelete = Interfaces.ITableDelete;
export declare type TableInsert = Interfaces.ITableInsert;
export declare type TableSelect = Interfaces.ITableSelect;
export declare type TableUpdate = Interfaces.ITableUpdate;
export declare type Column = Types.Column;
export declare type ConnectionOptions = Types.ConnectionOptions;
export declare type CreateCollectionOptions = Types.CreateCollectionOptions;
export declare type DataModel = Types.DataModel;
export declare type DataModelConstant = Types.DataModelConstant;
export declare type Document = Types.Document;
export declare type Expression = Types.Expression;
export declare type FieldDefinition = Types.FieldDefinition;
export declare type IndexDefinition = Types.IndexDefinition;
export declare type LockContention = Types.LockContention;
export declare type LockContentionConstant = Types.LockContentionConstant;
export declare type Metadata = Types.Metadata;
export declare type OperationWarning = Types.OperationWarning;
export declare type ParserOptions = Types.ParserOptions;
export declare type PoolingOptions = Types.PoolingOptions;
export declare type Projection = Types.Projection;
export declare type ProtobufObject = Types.ProtobufObject;
export declare type Row = Types.Row;
export declare type SearchCondition = Types.SearchCondition;
export declare type SearchConditionString = Types.SearchConditionString;
export declare const LockContention: LockContentionConstant;
export declare const DataModel: DataModelConstant;
export declare function expr(expression: Expression, options?: ParserOptions): ProtobufObject;
export declare function getClient(connection: ConnectionOptions, pooling: PoolingOptions): ClientClass;
export declare function getSession(connection: ConnectionOptions): Promise<SessionClass>;
export declare function getVersion(): string;
export declare function getXVersion(): string;
declare const _default: {
    LockContention: Types.LockContentionConstant;
    DataModel: Types.DataModelConstant;
    expr: typeof expr;
    getClient: typeof getClient;
    getSession: typeof getSession;
    getVersion: typeof getVersion;
    getXVersion: typeof getXVersion;
};
export default _default;
